#!/usr/bin/perl
#-----------------------------------------------------------------------
# echo.cgi - utility used by WYSIWYG html editor
#
# arguments:
#  html = url+mime+hash encoded html snippet
#  cms = if true, perform limited CMS substitutions on content
#-----------------------------------------------------------------------
#
#   Copyright 2001-2004 Exware Solutions, Inc.  http://www.exware.com
#
#   This file is part of ExSite WebWare (ExSite, for short).
#
#   ExSite is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   ExSite is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with ExSite; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#   Users requiring warranty coverage and/or support may arrange alternate
#   commercial licensing for ExSite, by contacting Exware Solutions 
#   via the website noted above.
#
#----------------------------------------------------------------------------

use strict;
use ExSite::Config;
use ExSite::Form;
use ExSite::Misc;
use vars qw(%input $db $html);

&exsite_init;

%input = &DecodeQuery;
$db = new ExSite::Form;

$db->authorize;
$html = ($input{action} eq "insert")? "" : &get_html;
print "Content-type: text/html\n\n";
print "<html>
<script language=\"javascript\">\n<!--\nvar pl_image = newImage();\npl_image.src = '$config{server}{HTMLpath}/_ExSite/images/checker/png';\n//-->\n</script>
$html</html>\n";

sub get_html {
	if (! $input{tab} || ! $input{col} || ! $input{id}) {
		return "Error - missing arguments"; 
	} 
	if (! exists $db->{map}->{tables}->{$input{tab}} ) {
		return "Error - no such table as <b>$input{tab}</b>";
	} 
	#if ($db->{map}->get($table,$column,"datatype") ne "html" ) {
	#	return "Error - column <b>$column</b> in table <b>$table</b> is not of type <b>html</b>";
	#} 
	my $content;
	if ($input{cms} && $input{tab} eq "content_data") {
	    # potential for CMS substitutions
	    require ExSite::ContentData;
	    my $cdata = new ExSite::ContentData(id=>$input{id});
	    if ($cdata->content_type() eq "text/html") {
		$content = $cdata->expand(method=>"url,dummy-content,dummy-module");
	    }
	}
	else {
	    my %data = $db->fetch($input{tab},$input{id});
	    if (! exists $data{$input{col}}) {
		return "Error - cannot retrieve column <b>$input{col}</b> in table <b>$input{tab}</b> where <b>id=$input{id}</b><br>You do not have permission to access this data.";
	    } 
	    $content = $data{$input{col}};
	}
#<<<<<<< echo.cgi
#	$content = $db->replace_tag($content);
#=======
#	# not sure why this was done...
#	#$content =~ s/[\r\n]/\ /g;
	$content =~ s/<table(\s*|\w*|\d*)>(.+)<\/table>/$1/g; 
#	#$content = $db->replace_tag($content);
#>>>>>>> 1.5
	return $content;
}
