#!/usr/bin/perl
#-----------------------------------------------------------------------
# export.cgi
#-----------------------------------------------------------------------

use strict;
use CGI::Carp qw(fatalsToBrowser);
use ExSite::Config qw(:OLD);
use ExSite::Form;  # use Form if inputting or processing forms
use ExSite::Report;
use ExSite::Misc;
use ExSite::DBmap;
use Excel;
use DEBUG;
#
# hard constants
#
&exsite_init;
&set_old_config_vars;
my $DEBUG=0;
my $DEBUG=0;
#
# setup & connect to database
#
my $bug=new DEBUG($DEBUG);
my $db = new ExSite::Report;
my $dbmap=new ExSite::DBmap;

#
# fetch any query arguments
#
my %query;
if ($ENV{REQUEST_METHOD}=~/get/i){%query=&DecodeQuery;}
else{%query=&DecodePost;}
my $OK=$db->authenticate;

if (!defined $query{where}){
    &page_header("Export Data",$db);
}
if ($OK==0){
    print"<h1> You are not allowed to access the contents of this page </h1>";
    exit;
}

#
#####
##### script logic goes here
##### NB: the generic script does nothing, and the body of the page
##### will be blank
#####
#
# show any debug statements
#
#this is the first pass so that it will ask the user whether to do the import or export and which table
if (!defined $query{table} || !defined $query{where})
{
    my %allowed_tables=("author_link"=>"Author Link","contact"=>"Contact","document"=>"Document","email"=>"Email","link"=>"LInk","member"=>"Member","message"=>"Message","publication"=>"Publication","release"=>"Release");
    print"<h1>Step One: Please select the table you wish to export</h1>\n";
    print"<form method=post>\n";
    print"<select name=table>\n";
    foreach (keys(%allowed_tables)){
	print"<option value=$_>$allowed_tables{$_}</option>\n";
    }
    print"</select>\n"; 
    print"<h1>Step Two:  Please select where to export</h1>\n";
    print"<select name=where>\n";
    print"<option name=text>As a text file</option>\n";
    print"<option name=excel>As an excel file</option>\n";
    print"</select>";
    print"</br>";
    &FormButtons;
    print"</form>\n";
}	
else{
    my ($data,$uid,$gid,%match,$mid_name,$gid_name);
    #get the group id and user id
    $gid=$db->my_gid;
    $uid=$db->my_uid;
   
    #exporting the files (be it text or excel)
    if ($query{where}=~/excel/){
	my $excel=new Excel();
	&Determine_id_name;
	print"Content-type:  applicaton/vnd.ms-excel\n\n";
	$excel->Export($data,"-");
    }
    else{
	#my $show;
	#$show->[0]="honorific"; $show->[1]="member_id";
	&Determine_id_name;
	my $output=$db->export_text($query{table},\%match);
	print"Content-type:  text/plain\n\n";
	print"$output";
	
    }
    sub Determine_id_name{
	if ($query{table}=~/memb/){
	    $gid_name="member_group_id";
	    $mid_name="member_id";
	}
	elsif ($query{table}=~/relea/ || $query{table}=~/link/){
	    $gid_name="group_id";
	    $mid_name="member_id";
	}
	elsif ($query{table}=~/messa/ || $query{table}=~/docu/ || $query{table}=~/author_li/){
	    $mid_name="member_id";
	}
       
	if (defined $uid && defined $gid){	    
	    if ($query{table}=~/memb/ || $query{table}=~/relea/ || $query{table}=~/link/){
		%match=($mid_name=>$uid, $gid_name=>$gid);	   
	    }
	    else{
		%match=($mid_name=>$uid);
	    }
	    $data=$db->fetch_match("$query{table}",\%match);	    
	}
	elsif(defined $uid){
	    %match=($mid_name=>$uid);
	    $data=$db->fetch_match("$query{table}",\%match);
	}
	else{
	    $data=$db->fetch_all("$query{table}");
	}	
    }
	

}
   

$bug->show;
#
&page_footer($db) if (!defined $query{where});

sub FormButtons
{
print "<INPUT TYPE=submit value=Submit name=Submit> ";
print "<INPUT TYPE=button value=Cancel name=Cancel onclick=\"javascript:history.back();\"> ";
print "<INPUT TYPE=reset name=Reset>";
}


### END

